#!/usr/bin/perl
#     db-   .

use strict ;
use BerkeleyDB;
use Socket;

use constant DB_CACHE_SIZE => 5242880; #       DB .

#    IP  .
my $cfg_block_weight = 3;

#       IP      -
#      ,    
#  ,        
#    cfg_block_weight

my $cfg_nospam_timetolive = 30 * 24*60*60; # 30 .

#     .
my $cfg_data_path="/var/log/antispam";
my $cfg_checker_cache_file = "$cfg_data_path/checked_ip.db";

#    .
#	 0 -   
#        1 -      IP.
#        2 -     IP  .
my $cfg_verbose_level = 2;

###############################################################################
# End of configuration block
###############################################################################

#     .
my $now_time = time();


    #       .
    my %chk_cache;
    tie (%chk_cache, 'BerkeleyDB::Btree',
	-Filename   => $cfg_checker_cache_file,
	-Flags      => DB_CREATE,
	-Cachesize   => DB_CACHE_SIZE) or die "ERROR:Cannot create/open $cfg_checker_cache_file: $!";

    #    .
    foreach my $cur_num_ip (keys %chk_cache){
	my $cur_ip = inet_ntoa($cur_num_ip);
        my ($cur_time, $cur_con, $cur_weight) = split(/\:/, $chk_cache{$cur_num_ip});

        my ($sec,$min,$hour,$mday,$mon,$year) = localtime($cur_time);
	my $str_time = sprintf("%2.2d %2.2d %d %2.2d:%2.2d:%2.2d",$mday, $mon+1, 1900+$year, $hour, $min, $sec);

	if ($cur_weight >= $cfg_block_weight){
    	    if ($cur_time + $cfg_nospam_timetolive < $now_time){
		delete $chk_cache{$cur_num_ip};
		if ($cfg_verbose_level > 0){
		    print "DEL SPAM:$cur_ip:$cur_con:$cur_weight:$str_time\n";
		}
	    } elsif ($cfg_verbose_level > 1){
		print "SKIP SPAM:$cur_ip:$cur_con:$cur_weight:$str_time\n";
	    }
	} elsif ($cfg_verbose_level > 1){
	    print "SKIP OK:$cur_ip:$cur_con:$cur_weight:$str_time\n";
	}
    }

    untie %chk_cache;
